#include "tokens.hh"

const std::string GetTokenName(QBtoken tok)
{
    unsigned ch = (unsigned)tok;
    if(ch <= 256)
    {
        if(ch < 32 || ch >= 127) 
        {
        literal:
            char Buf[32]; sprintf(Buf, "(char)%u", ch);
            return Buf;
        }
        if(ch == (unsigned)'\'') return "\"'\"";
        char Buf[32];
        sprintf(Buf, "'%c'", ch);
        return Buf;
    }
    switch(tok)
    {
case UNKNOWN_CHARACTER: return "UNKNOWN_CHARACTER";
case ABS: return "ABS";
case ACCESS: return "ACCESS";
case ALIAS: return "ALIAS";
case AND: return "AND";
case APPEND: return "APPEND";
case AS: return "AS";
case ASC: return "ASC";
case ATN: return "ATN";
case BINARY: return "BINARY";
case BYVAL: return "BYVAL";
case CALL: return "CALL";
case CASE: return "CASE";
case CDBL: return "CDBL";
case CDECL: return "CDECL";
case CHR_S: return "CHR_S";
case CINT: return "CINT";
case CIRCLE: return "CIRCLE";
case CLNG: return "CLNG";
case CLOSE: return "CLOSE";
case CLS: return "CLS";
case COLONCHAR: return "COLONCHAR";
case COLOR: return "COLOR";
case COMMON: return "COMMON";
case CONST: return "CONST";
case COS: return "COS";
case CRLF: return "CRLF";
case CSNG: return "CSNG";
case CSRLIN: return "CSRLIN";
case CVD: return "CVD";
case CVI: return "CVI";
case CVL: return "CVL";
case CVS: return "CVS";
case DATA: return "DATA";
case DATE_S: return "DATE_S";
case DECLAREFUNCTION: return "DECLAREFUNCTION";
case DECLARESUB: return "DECLARESUB";
case DEF: return "DEF";
case DEFSEG: return "DEFSEG";
case DIM: return "DIM";
case DO: return "DO";
case DOUBLE: return "DOUBLE";
case DOUNTIL: return "DOUNTIL";
case DOWHILE: return "DOWHILE";
case DRAW: return "DRAW";
case ELSE: return "ELSE";
case ELSEIF: return "ELSEIF";
case END: return "END";
case ENDDEF: return "ENDDEF";
case ENDFUNCTION: return "ENDFUNCTION";
case ENDIF: return "ENDIF";
case ENDSELECT: return "ENDSELECT";
case ENDSUB: return "ENDSUB";
case ENDTYPE: return "ENDTYPE";
case ENVIRON_S: return "ENVIRON_S";
case EQV: return "EQV";
case ERL: return "ERL";
case ERR: return "ERR";
case ERASE: return "ERASE";
case ERROR: return "ERROR";
case EXITDEF: return "EXITDEF";
case EXITDO: return "EXITDO";
case EXITFOR: return "EXITFOR";
case EXITFUNCTION: return "EXITFUNCTION";
case EXITSUB: return "EXITSUB";
case EXP: return "EXP";
case FILEATTR: return "FILEATTR";
case FILENUM: return "FILENUM";
case FIX: return "FIX";
case FNIDENTIFIER: return "FNIDENTIFIER";
case FOR: return "FOR";
case FRE: return "FRE";
case FREEFILE: return "FREEFILE";
case FUNCTION: return "FUNCTION";
case GET: return "GET";
case GOSUB: return "GOSUB";
case GOTO: return "GOTO";
case GREATEROREQUAL: return "GREATEROREQUAL";
case HEX_S: return "HEX_S";
case IDENTIFIER: return "IDENTIFIER";
case IF: return "IF";
case IMP: return "IMP";
case INKEY_S: return "INKEY_S";
case INP: return "INP";
case INPUT: return "INPUT";
case INPUT_F: return "INPUT_F";
case INPUT_S: return "INPUT_S";
case INSTR: return "INSTR";
case INT: return "INT";
case INTEGER: return "INTEGER";
case IS: return "IS";
case KEY: return "KEY";
case LBOUND: return "LBOUND";
case LCASE_S: return "LCASE_S";
case LEFT_S: return "LEFT_S";
case LEN: return "LEN";
case LESSOREQUAL: return "LESSOREQUAL";
case LET: return "LET";
case LINE: return "LINE";
case LINEINPUT: return "LINEINPUT";
case LINEINPUT_F: return "LINEINPUT_F";
case LIST: return "LIST";
case LOC: return "LOC";
case LOCATE: return "LOCATE";
case LOCK: return "LOCK";
case LOF: return "LOF";
case LOG: return "LOG";
case LONG: return "LONG";
case LOOP: return "LOOP";
case LOOPUNTIL: return "LOOPUNTIL";
case LOOPWHILE: return "LOOPWHILE";
case LPOS: return "LPOS";
case LPRINT: return "LPRINT";
case LTRIM_S: return "LTRIM_S";
case MID_S: return "MID_S";
case MKD_S: return "MKD_S";
case MKI_S: return "MKI_S";
case MKL_S: return "MKL_S";
case MKS_S: return "MKS_S";
case MOD: return "MOD";
case NEGATIONPRIORITY: return "NEGATIONPRIORITY";
case NEXT: return "NEXT";
case NOT: return "NOT";
case NOTEQUAL: return "NOTEQUAL";
case NUMBER: return "NUMBER";
case OCT_S: return "OCT_S";
case OFF: return "OFF";
case ON: return "ON";
case ON_KEY: return "ON_KEY";
case ON_PLAY: return "ON_PLAY";
case ON_ERROR: return "ON_ERROR";
case ON_TIMER: return "ON_TIMER";
case OPEN: return "OPEN";
case OPTION_BASE: return "OPTION_BASE";
case OR: return "OR";
case OUT: return "OUT";
case OUTPUT: return "OUTPUT";
case PAINT: return "PAINT";
case PALETTE: return "PALETTE";
case PEEK: return "PEEK";
case PLAY: return "PLAY";
case POINT: return "POINT";
case POKE: return "POKE";
case POS: return "POS";
case PRESET: return "PRESET";
case PRINT: return "PRINT";
case PRINT_F: return "PRINT_F";
case PSET: return "PSET";
case PUT: return "PUT";
case RANDOM: return "RANDOM";
case READ: return "READ";
case REDIM: return "REDIM";
case REM: return "REM";
case RESTORE: return "RESTORE";
case RESUME: return "RESUME";
case RETURN: return "RETURN";
case RIGHT_S: return "RIGHT_S";
case RND: return "RND";
case RTRIM_S: return "RTRIM_S";
case SCREEN: return "SCREEN";
case SEG: return "SEG";
case SELECT: return "SELECT";
case SHARED: return "SHARED";
case SINGLE: return "SINGLE";
case SPACE_S: return "SPACE_S";
case SPC: return "SPC";
case SQR: return "SQR";
case STATIC: return "STATIC";
case STEP: return "STEP";
case STOP: return "STOP";
case STRING: return "STRING";
case STRINGCONST: return "STRINGCONST";
case STRING_S: return "STRING_S";
case STR_S: return "STR_S";
case SUB: return "SUB";
case SYSTEM: return "SYSTEM";
case TAB: return "TAB";
case TAN: return "TAN";
case THEN: return "THEN";
case TIMER: return "TIMER";
case TIME_S: return "TIME_S";
case TO: return "TO";
case TYPE: return "TYPE";
case UBOUND: return "UBOUND";
case UCASE_S: return "UCASE_S";
case USING: return "USING";
case VAL: return "VAL";
case VARPTR: return "VARPTR";
case VARPTR_S: return "VARPTR_S";
case VARSEG: return "VARSEG";
case VIEW: return "VIEW";
case VIEWPRINT: return "VIEWPRINT";
case WAIT: return "WAIT";
case WRITE: return "WRITE";
case XOR: return "XOR";
    }
    goto literal;
}
